diff --git a/doc/guides/rel_notes/release_22_03.rst b/doc/guides/rel_notes/release_22_03.rst
index 60e5b4f9aa..e33605288a 100644
--- a/doc/guides/rel_notes/release_22_03.rst
+++ b/doc/guides/rel_notes/release_22_03.rst
@@ -332,3 +332,100 @@ Tested Platforms
    This section is a comment. Do not overwrite or remove it.
    Also, make sure to start the actual text at the margin.
    =======================================================
+
+   * Intel\ |reg| platforms with Intel\ |reg| NICs combinations
+
+     * CPU
+
+       * Intel\ |reg| Atom\ |trade| CPU C3758 @ 2.20GHz
+       * Intel\ |reg| Xeon\ |reg| CPU D-1553N @ 2.30GHz
+       * Intel\ |reg| Xeon\ |reg| CPU E5-2680 v2 @ 2.80GHz
+       * Intel\ |reg| Xeon\ |reg| CPU E5-2699 v3 @ 2.30GHz
+       * Intel\ |reg| Xeon\ |reg| CPU E5-2699 v4 @ 2.20GHz
+       * Intel\ |reg| Xeon\ |reg| Gold 6139 CPU @ 2.30GHz
+       * Intel\ |reg| Xeon\ |reg| Gold 6140M CPU @ 2.30GHz
+       * Intel\ |reg| Xeon\ |reg| Gold 6252N CPU @ 2.30GHz
+       * Intel\ |reg| Xeon\ |reg| Gold 6348 CPU @ 2.60GHz
+       * Intel\ |reg| Xeon\ |reg| Platinum 8180 CPU @ 2.50GHz
+       * Intel\ |reg| Xeon\ |reg| Platinum 8180M CPU @ 2.50GHz
+       * Intel\ |reg| Xeon\ |reg| Platinum 8280M CPU @ 2.70GHz
+       * Intel\ |reg| Xeon\ |reg| Platinum 8380 CPU @ 2.30GHz
+
+     * OS:
+
+       * Fedora 35
+       * OpenWRT 21.02.1
+       * FreeBSD 13.0
+       * Red Hat Enterprise Linux Server release 8.4
+       * Red Hat Enterprise Linux Server release 8.5
+       * Suse 15 SP3
+       * Ubuntu 20.04.3
+       * Ubuntu 21.10
+
+     * NICs:
+
+       * Intel\ |reg| Ethernet Controller E810-C for SFP (4x25G)
+
+         * Firmware version: 3.22 0x8000d83c 1.3146.0
+         * Device id (pf/vf): 8086:1593 / 8086:1889
+         * Driver version: 1.8.3_2_g5c2ff303 (ice)
+         * OS Default DDP: 1.3.28.0
+         * COMMS DDP: 1.3.35.0
+         * Wireless Edge DDP: 1.3.8.0
+
+       * Intel\ |reg| Ethernet Controller E810-C for QSFP (2x100G)
+
+         * Firmware version: 3.20 0x8000d83e 1.3146.0
+         * Device id (pf/vf): 8086:1592 / 8086:1889
+         * Driver version: 1.8.3_2_g5c2ff303 (ice)
+         * OS Default DDP: 1.3.28.0
+         * COMMS DDP: 1.3.35.0
+         * Wireless Edge DDP: 1.3.8.0
+
+       * Intel\ |reg| 82599ES 10 Gigabit Ethernet Controller
+
+         * Firmware version: 0x61bf0001
+         * Device id (pf/vf): 8086:10fb / 8086:10ed
+         * Driver version(in-tree): 5.1.0-k (ixgbe)
+         * Driver version(out-tree): 5.13.4 (ixgbe)
+
+       * Intel\ |reg| Ethernet Converged Network Adapter X710-DA4 (4x10G)
+
+         * Firmware version(PF): 8.30 0x8000a49d 1.2926.0
+         * Firmware version(VF): 8.50 0x8000b6d9 1.3082.0
+         * Device id (pf/vf): 8086:1572 / 8086:154c
+         * Driver version: 2.17.15 (i40e)
+
+       * Intel\ |reg| Corporation Ethernet Connection X722 for 10GbE SFP+ (2x10G)
+
+         * Firmware version: 5.50 0x80003327 1.3082.0
+         * Device id (pf/vf): 8086:37d0 / 8086:37cd
+         * Driver version(out-tree): 2.17.15 (i40e)
+         * Driver version(in-tree): 2.8.20-k (i40e)
+
+       * Intel\ |reg| Corporation Ethernet Connection X722 for 10GBASE-T
+
+         * Firmware version: 5.50 0x800032e0 1.2935.0
+         * Device id (pf/vf): 8086:37d2 / 8086:37cd
+         * Driver version(out-tree): 2.17.15 (i40e)
+         * Driver version(in-tree): 2.8.20-k (i40e)
+
+       * Intel\ |reg| Ethernet Converged Network Adapter XXV710-DA2 (2x25G)
+
+         * Firmware version(PF): 8.30 0x8000a483 1.2926.0
+         * Firmware version(VF): 8.50 0x8000b703 1.3082.0
+         * Device id (pf/vf): 8086:158b / 8086:154c
+         * Driver version: 2.17.15 (i40e)
+
+       * Intel\ |reg| Ethernet Converged Network Adapter XL710-QDA2 (2X40G)
+
+         * Firmware version(PF): 8.30 0x8000a4ae 1.2926.0
+         * Firmware version(VF): 8.50 0x8000b6c7 1.3082.0
+         * Device id (pf/vf): 8086:1583 / 8086:154c
+         * Driver version: 2.17.15 (i40e)
+
+       * Intel\ |reg| Ethernet Converged Network Adapter X710-T2L
+
+         * Firmware version: 8.30 0x8000a489 1.2879.0
+         * Device id (pf): 8086:15ff
+         * Driver version: 2.17.15 (i40e)